



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android开发之重力传感器</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android开发之重力传感器</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 21:11:30 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>重力传感器与方向传感器的开发步骤类似，只要理清了期中的x,y,z的值之后就可以根据他们的变化来进行编程了，首先来看一副图</p>
<p><img referrerpolicy="no-referrer"src="http://c.jinhusns.com/Uploads/CMS/2014/10/20/635494112889100689.jpg" /></p>
<p>假设当地的重力加速度值为g</p>
<p>当手机正面朝上的时候,z的值为q，反面朝上的时候，z的值为-g</p>
<p>当手机右侧面朝上的时候，x的值为g,右侧面朝上的时候,x的值为-g</p>
<p>当手机上侧面朝上的时候，y的值为g,右侧面朝上的时候,y的值为-g</p>
<p>了解了重力传感器中X,Y，Z的含义之后下面我们就开始学习如何使用</p>
<p>首先我们创建一个传感器管理器和一个传感器监听器，管理器用来管理传感器以及创建各种各样的传感器，监听器用来监视传感器的变化并且进行相应的操作</p>
<p>private SensorManager sensorManager;</p>
<p>private MySensorEventListener mySensorEventListener;</p>
<p>mySensorEventListener= new MySensorEventListener();//这个监听器当然是我们自己定义的，在重力感 &nbsp; &nbsp; 应器感应到手机位置有变化的时候，我们可以采取相应的操作，这里紧紧是将x,y,z的值打印出来</p>
<p>private final class MySensorEventListener implements &nbsp;SensorEventListener{</p>
<p>@Override</p>
<p>//可以得到传感器实时测量出来的变化值</p>
<p>public void onSensorChanged(SensorEvent event) {</p>
<p>//重力传感器</p>
<p>if(event.sensor.getType()==Sensor.TYPE_ACCELEROMETER){</p>
<p>float x = event.values[SensorManager.DATA_X];</p>
<p>float y = event.values[SensorManager.DATA_Y];</p>
<p>float z = event.values[SensorManager.DATA_Z];</p>
<p>//tv_accelerometer是界面上的一个TextView标签，不再赘述</p>
<p>tv_orientation.setText("Orientation:"+x+","+y+","+z);</p>
<p>}</p>
<p>}</p>
<p>我们在onResume方法中创建重力传感器，并向系统注册监听器</p>
<p>protected void onResume() {</p>
<p>Sensor sensor_accelerometer=sensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER);</p>
<p>sensorManager.registerListener(mySensorEventListener,sensor_accelerometer, &nbsp; SensorManager.SENSOR_DELAY_UI);</p>
<p>super.onResume();</p>
<p>}</p>
<p>最后我们在onPause()中注销所有传感器的监听，释放重力感应器资源!</p>
<p>protected void onPause() {</p>
<p>/注销所有传感器的监听</p>
<p>sensorManager.unregisterListener(mySensorEventListener);</p>
<p>super.onPause();</p>
<p>}</p>
<p>到此，有关重力传感器的介绍完毕!</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39rn43dq.html">蚂蚁金服寒泉子：JVM源码分析之临门一脚的OutOfMemoryError完全解读</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jxwp4q.html">swift 初探NSURLSession</a>
		</li>
						<li><a href="https://www.batexi.com/a/390z10jq.html">bootstrap tooltip 显示提示信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xo2nz9.html">深度剖析C&plus;&plus;对象池自动回收技术实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zyv249.html">MSP430常见问题之FLASH存储类</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1mdy1q.html">【一天一道LeetCode】&num;13&period; Roman to Integer</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy17pg2q.html">DSAPI 图形图像篇&lpar;上&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwnkrd8.html">vue drag 对表格的列进行拖动排序</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2x30o9.html">HTML标签转义方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1kj119.html">自己写的一个jQuery对联广告插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kodd03q.html">&lbrack;NOI1997&rsqb; 积木游戏</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwle1ky9.html">【Android】7&period;4TableLayout（表格布局）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpox579.html">hive 2以上版本启动异常 Unable to instantiate org&period;apache&period;hadoop&period;hive&period;ql&period;metadata&period;SessionHiveMetaStoreClient</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjgyn28.html">使用Jacob与Word文件交互</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mdm7g08.html">开机启动服务（ftp、apache、mysql）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96m7zy48.html">洛谷&mdash;&mdash;P2097 资料分发1</a>
		</li>
						<li><a href="https://www.batexi.com/a/9g3znveq.html">Spring课程 Spring入门篇 5-2 配置切面aspect</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlo7vv1q.html">Oracle Linux 7&period;3下载与  dtrace安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8md45268.html">maya2017安装失败如何卸载重装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qndpgr38.html">java处理中日文字符串的乱码问题</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r93wjxwq.html">自己动手模拟开发一个简单的Web服务器</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyy4ggq.html">Android学习&mdash;&mdash;uses-sdk标签详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/390remj9.html">在JavaScript中对HTML进行反转义</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnv5628.html">【Android环境搭建】解决安装使用SDK Manager更新时的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8e4wlz9.html">easyuidatagrid中load&comma;reload&comma;loadData的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m2yzoq.html">没有Hyper-V服务，WP Emulator无法启动</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q25g13q.html">SQL Server 自动增长过大</a>
			</li>
						<li><a href="https://www.batexi.com/a/m960zzn9.html">Change Line Type in OpenCascade</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxd4wd9.html">Android 在Service中弹出对话框</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxdxez9.html">基于Bootstrap里面的Button dropdown打造自定义select</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
